<template>
    <div class="col-md-4 offset-md-4">
      <form @submit.prevent="handleUpdate()" class="card card-body">
        <h1 class="card-title my-3 text-center">Actualizar Empleado</h1>
        <span>Primer Nombre: </span>
        <input
            class="form-control mb-3"
            placeholder="Primer Nombre"
            type="title"
            v-model="currentUser.fistName"
            autofocus
          />
          <span>Otros Nombres: </span>
          <input
            class="form-control mb-3"
            placeholder="Otros Nombres"
            rows="3"
            v-model="currentUser.otherName"
          />
          <span>Primer Apellido: </span>
          <input
            class="form-control mb-3"
            placeholder="Primer Apellido"
            type="title"
            v-model="currentUser.firstSurname"
            autofocus
          />
          <span>Segndo Apellido: </span>
          <input
            class="form-control mb-3"
            placeholder="Segndo Apellido"
            rows="3"
            v-model="currentUser.secondSurname"
          />
          <span>Tipo de documento: </span>
          <select v-model="currentUser.idType" class="form-select mb-3" aria-label="Default select example">
            <option selected value="Cédula de Ciudadanía">Cédula de Ciudadanía</option>
            <option value="Cédula de Ciudadanía">Cédula de Extranjería</option>
            <option value="Pasaporte">Pasaporte</option>
            <option value="Permiso Especial">Permiso Especial</option>
          </select>
          <span>Numero de identificacion: </span>
          <input
            class="form-control mb-3"
            placeholder="Número de Identificación"
            rows="3"
            v-model="currentUser.idNumber"
          />
          <span>País: </span>
          <select v-model="currentUser.country" class="form-select mb-3">
            <option selected value={currentUser.country}>Colombia </option>
            <option value="Estados Unidos">Estados Unidos</option>
          </select>
          <span>Fecha de ingreso: </span>
          <input
            class="form-control mb-3"
            placeholder="Fecha de ingreso"
            type="date"
            v-model="currentUser.dateIn"
            autofocus
          />
        <button class="btn btn-primary">Update</button>
      </form>
      <button @click="handleDelete()" class="btn btn-danger my-4">delete</button>
    </div>
  </template>
  
  <script lang="ts">
  import { defineComponent } from "vue";
  import { User } from "@/interfaces/user";
  import { deleteTask, getTask, updateTask } from "@/services/userServices";
  export default defineComponent({
    name: "user-detail",
    data() {
      return {
        currentUser: {} as User,
      };
    },
    methods: {
      async loadTask(id: string) {
        try {
          const { data } = await getTask(id);
          this.currentUser = data;
        } catch (error) {
          console.error(error);
        }
      },
      async handleUpdate() {
        try {
          if (typeof this.$route.params.id === "string") {
            await updateTask(this.$route.params.id, this.currentUser);
            this.$router.push("/");
          }
        } catch (error) {
          console.error(error);
        }
      },
      async handleDelete() {
        try {
          if (typeof this.$route.params.id === "string") {
            deleteTask(this.$route.params.id);
            this.$router.push("/");
          }
        } catch (error) {
          console.error(error);
        }
      },
    },
    mounted() {
      if (typeof this.$route.params.id === "string") {
        this.loadTask(this.$route.params.id);
      }
    },
  });
  </script>